﻿
CompilerIf #False
  ;start
  
  ;{ Window
  OpenWindow(any,x,y,width,height,title.s,flag=0,parentID=0);windowevent
  ;}
  ;{ Image
  CatchImage(any,adr,size);lastzero
  CopyImage(img1,any)
  CreateImage(any,w,h,d=24,b=#Black)
  GrabImage(img1,any,x,y,w,h)
  LoadImage(any,file.s,flag=0)
  ;}
  ;{ Menu
  CreateImageMenu(any, winid,flags=0)
  CreateMenu(any,winid)
  CreatePopupImageMenu(any, flags=0)
  CreatePopupMenu(any)
  ;}
  ;{ gadget
  ButtonGadget(any,x,y,w,h,text.s,flags=0)                               ;gadgetevent
  ButtonImageGadget(any,x,y,w,h,imgid,flags=0)                           ;gadgetevent
  CalendarGadget(any,x,y,w,h,d=0,f=0)                                    ;gadgetevent
  CanvasGadget(any,x,y,w,h,f=0)                                          ;gadgetevent
  CheckBoxGadget(any,x,y,w,h,t.s,f=0)                                    ;gadgetevent
  ComboBoxGadget(any,x,y,w,h,f=0)                                        ;gadgetevent
  ContainerGadget(any,x,y,w,h,f=#PB_Container_BorderLess)                ;gadgetevent
  DateGadget(any,x,y,w,h,m.s,d,f=0)                                      ;gadgetevent
  EditorGadget(any,x,y,w,h,f=0)                                          ;gadgetevent
  ExplorerComboGadget(any,x,y,w,h,dir.s,flags=0)                         ;gadgetevent
  ExplorerListGadget(any,x,y,w,h,dir.s,flags=0)                          ;gadgetevent
  ExplorerTreeGadget(any,x,y,w,h,dir.s,flags=0)                          ;gadgetevent
  FrameGadget(any,x,y,w,h,text.s,flags=0)                                ;gadgetevent
  HyperLinkGadget(any,x,y,w,h,text.s,color,flags=0)                      ;gadgetevent
  ImageGadget(any,x,y,w,h,imageid,flags=0)                               ;gadgetevent
  ListIconGadget(any,x,y,w,h,col.s,colw,flags=0)                         ;gadgetevent
  ListViewGadget(any,x,y,w,h,flags=0)                                    ;gadgetevent
  MDIGadget(any,x,y,w,h,submenu,firstmenuitem,flags=0)                   ;gadgetevent
  OpenGLGadget(any,x,y,w,h,flags=0)                                      ;gadgetevent
  OptionGadget(any,x,y,w,h,text.s)                                       ;gadgetevent
  PanelGadget(any,x,y,w,h)                                               ;gadgetevent
  ProgressBarGadget(any,x,y,w,h,min,max,flags=0)                         ;gadgetevent
  ScrollAreaGadget(any,x,y,w,h,scrollw,scrollh,scrollstep=10,flags=0)    ;gadgetevent
  ScrollBarGadget(any,x,y,w,h,min,max,page,flags=0)                      ;gadgetevent
  ShortcutGadget(any,x,y,w,h,shortcut)                                   ;gadgetevent
  SpinGadget(any,x,y,w,h,min,max,flags=0)                                ;gadgetevent
  SplitterGadget(any,x,y,w,h,gad1,gad2,flags=0)                          ;gadgetevent
  StringGadget(any,x,y,w,h,text.s,flags=0)                               ;gadgetevent
  TextGadget(any,x,y,w,h,text.s,flags=0)                                 ;gadgetevent
  TrackBarGadget(any,x,y,w,h,min,max,flags=0)                            ;gadgetevent
  TreeGadget(any,x,y,w,h,flags=0)                                        ;gadgetevent
  WebGadget(any,x,y,w,h,url.s)                                           ;gadgetevent
  
  ;}  
  ;{ Font
  LoadFont(any,name.s,height,f=0)
  ;}
  ;{ Pack
  CreatePack(any,file.s,p=#PB_PackerPlugin_Zip,level=9)
  OpenPack(any,file.s,p=#PB_PackerPlugin_Zip)
  ;}
  ;{ Statusbar
  CreateStatusBar(any,windowid)
  ;}
  
  ;end
CompilerEndIf


CompilerIf #PB_Compiler_IsMainFile
  
  Global NewList Fileline.s()
  
  Procedure AddLine(str.s)
    AddElement(Fileline())
    Fileline()=str
  EndProcedure
  
  
  Structure sNoAny
    name.s
    para.s
    NoDefaultPara.s
    NoDefaultParaWithoutLast.s
    StripPara.s
    DefaultPara.s
    comment.s
    last.s
  EndStructure
  NewList noAny.sNoAny()
  
  Define start=#False
  Define header=#True
  Define line.s,para.s,NoDefaultPara.s,DefaultPara.s,StripPara.s,str.s,NoDefaultParaWithoutLast.s,last.s
  
  in=ReadFile(#PB_Any,#PB_Compiler_File)
  If in
    While Not Eof(in)
      line=ReadString(in)
      
      If header
        AddElement(Fileline())
        Fileline()=line
      EndIf
      
      line=Trim(line)
      
      If line=";start"
        Start=#True
      ElseIf line=";end"
        start=#False
      ElseIf line=";-includestart"
        header=#False
        
      ElseIf start
        
        If Left(line,1)=";"
          AddElement(noAny())
          noAny()\name=line
        ElseIf FindString(line,"(")>0
          
          para=StringField(line,2,"(")
          para=StringField(para,1,")")
          
          count=CountString(para,",")
          StripPara=""
          DefaultPara=""
          NoDefaultPara=""
          NoDefaultParaWithoutLast=""
          last=""
          For i=1 To count+1
            str= StringField(para,i,",")
            str= StringField(str,1,"=")  
            NoDefaultPara+","+str
            If i<=count
              NoDefaultParaWithoutLast+","+str
            Else
              last=str
            EndIf            
            
            str= StringField(str,1,".")
            StripPara+","+str
            
            DefaultPara+","+str
            str= StringField(para,i,",")
            str= StringField(str,2,"=")
            If str<>""
              DefaultPara+"="+str
            EndIf
          Next
          StripPara=Mid(StripPara,2)
          DefaultPara=Mid(DefaultPara,2)
          NoDefaultPara=Mid(NoDefaultPara,2)
          NoDefaultParaWithoutLast.s=Mid(NoDefaultParaWithoutLast,2)
  
          AddElement(noAny())
          noAny()\name=StringField(line,1,"(")
          noAny()\comment=StringField(line,2,";")
          noAny()\para="("+para+")"
          noAny()\DefaultPara="("+DefaultPara+")"
          noAny()\NoDefaultParaWithoutLast="("+NoDefaultParaWithoutLast+")"
          noAny()\NoDefaultPara="("+NoDefaultPara+")"
          noAny()\StripPara="("+StripPara+")"
          noAny()\last=last
        EndIf
      EndIf
    Wend
    CloseFile(in)
  EndIf
  
  
  addline ("CompilerIf #PB_Compiler_IsIncludeFile")
  
  AddLine( "DeclareModule _NoAny" )
  AddLine( "  EnableExplicit" )
  AddLine( "" )
  ForEach noAny()
    If Left(noAny()\name,1)=";"
      AddLine( "" )
      AddLine( "  "+noAny()\name )
    Else
      AddLine( "  Declare "+ noAny()\name+"_" +ReplaceString( noAny()\NoDefaultPara, "any","*any.integer")  )
    EndIf
  Next
  AddLine( "" )
   
  AddLine( "  Macro _BindGadgetEvent(a,c,b)" )
  AddLine( "    CompilerIf Defined(c#_#b,#PB_Procedure)" )
  AddLine( "      BindGadgetEvent(a,@c#_#b(),#pb_eventtype_#b)" )
  AddLine( "    CompilerEndIf" )
  AddLine( "  EndMacro" )
  
  
  
  AddLine( "  Macro _BindEvent(a,c,b)" )
  AddLine( "    CompilerIf Defined(c#_#b,#PB_Procedure)" )
  AddLine( "      BindEvent(#pb_event_#b,@c#_#b(),a)" )
  AddLine( "    CompilerEndIf" )
  AddLine( "  EndMacro" )
  

  
  AddLine( "EndDeclareModule" )
  AddLine( "Module _NoAny" )
  AddLine( "" )
  ForEach noany()
    If Left(noAny()\name,1)=";"
      AddLine( "" )
      AddLine( "  "+noAny()\name )
    Else
      AddLine( "  Procedure " + noany()\name+"_" + ReplaceString( noAny()\NoDefaultPara, "any","*any.integer")  )
      If noAny()\comment="lastzero"        
        AddLine( "    if "+noAny()\last+"=0" )
        AddLine( "      *any\i = " + noany()\name + ReplaceString( noAny()\NoDefaultParaWithoutLast, "any","#pb_any" ) )
        AddLine( "    else" )
        AddLine( "      *any\i = " + noany()\name + ReplaceString( noAny()\NoDefaultPara, "any","#pb_any" ) )
        AddLine( "    endif" )
      Else
        
        AddLine( "    *any\i = " + noany()\name + ReplaceString( noAny()\NoDefaultPara, "any","#pb_any" ) )
      EndIf
      
      AddLine( "    ProcedureReturn *any\i" )
      AddLine( "  EndProcedure" )
    EndIf
  Next
  addline( "EndModule")
  AddLine( "" )
  AddLine( "DeclareModule NoAny" )
  AddLine( "  EnableExplicit" )
  AddLine( "  Macro SetGadgetEvent(a,c)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,change)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,focus)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,lostfocus)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,leftclick)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,rightclick)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,mouseenter)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,mouseleave)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,mousemove)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,mousewheel)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,leftbuttondown)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,leftbuttonup)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,leftdoubleclick)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,rightbuttondown)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,rightbuttonup)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,rightdoubleclick)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,middlebuttondown)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,middlebuttonup)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,keydown)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,keyup)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,input)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,resize)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,up)" )
  AddLine( "    _noany::_BindGadgetEvent(a,c,down)" )
  AddLine( "    CompilerIf Defined(c#_all,#PB_Procedure)" )
  AddLine( "      BindGadgetEvent(a,@c#_all(),#PB_All)" )
  AddLine( "    CompilerEndIf" )
  AddLine( "  EndMacro" )
  AddLine( "  macro SetWindowEvent(any,c)" )
  AddLine( "    _NoAny::_BindEvent(any,c,menu)" )
  AddLine( "    _NoAny::_BindEvent(any,c,gadget)" )
  AddLine( "    _NoAny::_BindEvent(any,c,systray)" )
  AddLine( "    _NoAny::_BindEvent(any,c,timer)" )
  AddLine( "    _NoAny::_BindEvent(any,c,CloseWindow)" )
  AddLine( "    _NoAny::_BindEvent(any,c,Repaint)" )
  AddLine( "    _NoAny::_BindEvent(any,c,sizewindow)" )
  AddLine( "    _NoAny::_BindEvent(any,c,movewindow)" )
  AddLine( "    _NoAny::_BindEvent(any,c,minimizewindow)" )
  AddLine( "    _NoAny::_BindEvent(any,c,maximizewindow)" )
  AddLine( "    _NoAny::_BindEvent(any,c,restorewindow)" )
  AddLine( "    _NoAny::_BindEvent(any,c,activatewindow)" )
  AddLine( "    _NoAny::_BindEvent(any,c,deactivatewindow)" )
  AddLine( "    _NoAny::_BindEvent(any,c,windowdrop)" )
  AddLine( "    _NoAny::_BindEvent(any,c,gadgetdrop)" )
  AddLine( "    _NoAny::_BindEvent(any,c,rightclick)" )
  AddLine( "    _NoAny::_BindEvent(any,c,leftclick)" )
  AddLine( "    _NoAny::_BindEvent(any,c,leftdoubleclick)" )
  AddLine("  EndMacro" )
  AddLine( "" )
  ForEach noany()  
    If Left(noAny()\name,1)=";"
      AddLine( "" )
      AddLine( "  "+noAny()\name )
    Else
      AddLine( "  Macro "+ noany()\name + noAny()\DefaultPara       )
      AddLine( "    _noAny::" + noany()\name+"_" + ReplaceString( noAny()\stripPara, "any","@any" ) )
      If noAny()\comment="gadgetevent"
        AddLine( "    noany::SetGadgetEvent(any,any)"   )
      ElseIf noAny()\comment="windowevent"        
        AddLine( "    noany::SetWindowEvent(any,any)"   )
      EndIf           
      AddLine( "  EndMacro" )
      
      If noAny()\comment="gadgetevent" Or noAny()\comment="windowevent"  
        AddLine( "  Macro "+ noany()\name+"_noEvent" + noAny()\DefaultPara )
        AddLine( "    _noAny::" + noany()\name+"_" + ReplaceString( noAny()\stripPara, "any","@any" ) )
        AddLine( "  EndMacro" )
      EndIf
    EndIf

  Next
  AddLine( "" )
  AddLine( "EndDeclareModule" )
  AddLine( "Module NoAny" )
  AddLine( "EndModule" )
  addline( "" )
  AddLine( "UseModule NoAny" )
  
  addline("compilerendif")
  addline( "" )
  addline( "" )
  addline( "" )
  out=CreateFile(#PB_Any,#PB_Compiler_File)
  If out
    ForEach Fileline()
      WriteStringN(out,Fileline())
    Next
    CloseFile(out)
  EndIf
  
  
  
  
  End
CompilerEndIf

;-includestart
CompilerIf #PB_Compiler_IsIncludeFile
DeclareModule _NoAny
  EnableExplicit


  ;{ Window
  Declare OpenWindow_(*any.integer,x,y,width,height,title.s,flag,parentID)

  ;}

  ;{ Image
  Declare CatchImage_(*any.integer,adr,size)
  Declare CopyImage_(img1,*any.integer)
  Declare CreateImage_(*any.integer,w,h,d,b)
  Declare GrabImage_(img1,*any.integer,x,y,w,h)
  Declare LoadImage_(*any.integer,file.s,flag)

  ;}

  ;{ Menu
  Declare CreateImageMenu_(*any.integer, winid,flags)
  Declare CreateMenu_(*any.integer,winid)
  Declare CreatePopupImageMenu_(*any.integer, flags)
  Declare CreatePopupMenu_(*any.integer)

  ;}

  ;{ gadget
  Declare ButtonGadget_(*any.integer,x,y,w,h,text.s,flags)
  Declare ButtonImageGadget_(*any.integer,x,y,w,h,imgid,flags)
  Declare CalendarGadget_(*any.integer,x,y,w,h,d,f)
  Declare CanvasGadget_(*any.integer,x,y,w,h,f)
  Declare CheckBoxGadget_(*any.integer,x,y,w,h,t.s,f)
  Declare ComboBoxGadget_(*any.integer,x,y,w,h,f)
  Declare ContainerGadget_(*any.integer,x,y,w,h,f)
  Declare DateGadget_(*any.integer,x,y,w,h,m.s,d,f)
  Declare EditorGadget_(*any.integer,x,y,w,h,f)
  Declare ExplorerComboGadget_(*any.integer,x,y,w,h,dir.s,flags)
  Declare ExplorerListGadget_(*any.integer,x,y,w,h,dir.s,flags)
  Declare ExplorerTreeGadget_(*any.integer,x,y,w,h,dir.s,flags)
  Declare FrameGadget_(*any.integer,x,y,w,h,text.s,flags)
  Declare HyperLinkGadget_(*any.integer,x,y,w,h,text.s,color,flags)
  Declare ImageGadget_(*any.integer,x,y,w,h,imageid,flags)
  Declare ListIconGadget_(*any.integer,x,y,w,h,col.s,colw,flags)
  Declare ListViewGadget_(*any.integer,x,y,w,h,flags)
  Declare MDIGadget_(*any.integer,x,y,w,h,submenu,firstmenuitem,flags)
  Declare OpenGLGadget_(*any.integer,x,y,w,h,flags)
  Declare OptionGadget_(*any.integer,x,y,w,h,text.s)
  Declare PanelGadget_(*any.integer,x,y,w,h)
  Declare ProgressBarGadget_(*any.integer,x,y,w,h,min,max,flags)
  Declare ScrollAreaGadget_(*any.integer,x,y,w,h,scrollw,scrollh,scrollstep,flags)
  Declare ScrollBarGadget_(*any.integer,x,y,w,h,min,max,page,flags)
  Declare ShortcutGadget_(*any.integer,x,y,w,h,shortcut)
  Declare SpinGadget_(*any.integer,x,y,w,h,min,max,flags)
  Declare SplitterGadget_(*any.integer,x,y,w,h,gad1,gad2,flags)
  Declare StringGadget_(*any.integer,x,y,w,h,text.s,flags)
  Declare TextGadget_(*any.integer,x,y,w,h,text.s,flags)
  Declare TrackBarGadget_(*any.integer,x,y,w,h,min,max,flags)
  Declare TreeGadget_(*any.integer,x,y,w,h,flags)
  Declare WebGadget_(*any.integer,x,y,w,h,url.s)

  ;}

  ;{ Font
  Declare LoadFont_(*any.integer,name.s,height,f)

  ;}

  ;{ Pack
  Declare CreatePack_(*any.integer,file.s,p,level)
  Declare OpenPack_(*any.integer,file.s,p)

  ;}

  ;{ Statusbar
  Declare CreateStatusBar_(*any.integer,windowid)

  ;}

  Macro _BindGadgetEvent(a,c,b)
    CompilerIf Defined(c#_#b,#PB_Procedure)
      BindGadgetEvent(a,@c#_#b(),#pb_eventtype_#b)
    CompilerEndIf
  EndMacro
  Macro _BindEvent(a,c,b)
    CompilerIf Defined(c#_#b,#PB_Procedure)
      BindEvent(#pb_event_#b,@c#_#b(),a)
    CompilerEndIf
  EndMacro
EndDeclareModule
Module _NoAny


  ;{ Window
  Procedure OpenWindow_(*any.integer,x,y,width,height,title.s,flag,parentID)
    *any\i = OpenWindow(#pb_any,x,y,width,height,title.s,flag,parentID)
    ProcedureReturn *any\i
  EndProcedure

  ;}

  ;{ Image
  Procedure CatchImage_(*any.integer,adr,size)
    if size=0
      *any\i = CatchImage(#pb_any,adr)
    else
      *any\i = CatchImage(#pb_any,adr,size)
    endif
    ProcedureReturn *any\i
  EndProcedure
  Procedure CopyImage_(img1,*any.integer)
    *any\i = CopyImage(img1,#pb_any)
    ProcedureReturn *any\i
  EndProcedure
  Procedure CreateImage_(*any.integer,w,h,d,b)
    *any\i = CreateImage(#pb_any,w,h,d,b)
    ProcedureReturn *any\i
  EndProcedure
  Procedure GrabImage_(img1,*any.integer,x,y,w,h)
    *any\i = GrabImage(img1,#pb_any,x,y,w,h)
    ProcedureReturn *any\i
  EndProcedure
  Procedure LoadImage_(*any.integer,file.s,flag)
    *any\i = LoadImage(#pb_any,file.s,flag)
    ProcedureReturn *any\i
  EndProcedure

  ;}

  ;{ Menu
  Procedure CreateImageMenu_(*any.integer, winid,flags)
    *any\i = CreateImageMenu(#pb_any, winid,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure CreateMenu_(*any.integer,winid)
    *any\i = CreateMenu(#pb_any,winid)
    ProcedureReturn *any\i
  EndProcedure
  Procedure CreatePopupImageMenu_(*any.integer, flags)
    *any\i = CreatePopupImageMenu(#pb_any, flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure CreatePopupMenu_(*any.integer)
    *any\i = CreatePopupMenu(#pb_any)
    ProcedureReturn *any\i
  EndProcedure

  ;}

  ;{ gadget
  Procedure ButtonGadget_(*any.integer,x,y,w,h,text.s,flags)
    *any\i = ButtonGadget(#pb_any,x,y,w,h,text.s,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure ButtonImageGadget_(*any.integer,x,y,w,h,imgid,flags)
    *any\i = ButtonImageGadget(#pb_any,x,y,w,h,imgid,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure CalendarGadget_(*any.integer,x,y,w,h,d,f)
    *any\i = CalendarGadget(#pb_any,x,y,w,h,d,f)
    ProcedureReturn *any\i
  EndProcedure
  Procedure CanvasGadget_(*any.integer,x,y,w,h,f)
    *any\i = CanvasGadget(#pb_any,x,y,w,h,f)
    ProcedureReturn *any\i
  EndProcedure
  Procedure CheckBoxGadget_(*any.integer,x,y,w,h,t.s,f)
    *any\i = CheckBoxGadget(#pb_any,x,y,w,h,t.s,f)
    ProcedureReturn *any\i
  EndProcedure
  Procedure ComboBoxGadget_(*any.integer,x,y,w,h,f)
    *any\i = ComboBoxGadget(#pb_any,x,y,w,h,f)
    ProcedureReturn *any\i
  EndProcedure
  Procedure ContainerGadget_(*any.integer,x,y,w,h,f)
    *any\i = ContainerGadget(#pb_any,x,y,w,h,f)
    ProcedureReturn *any\i
  EndProcedure
  Procedure DateGadget_(*any.integer,x,y,w,h,m.s,d,f)
    *any\i = DateGadget(#pb_any,x,y,w,h,m.s,d,f)
    ProcedureReturn *any\i
  EndProcedure
  Procedure EditorGadget_(*any.integer,x,y,w,h,f)
    *any\i = EditorGadget(#pb_any,x,y,w,h,f)
    ProcedureReturn *any\i
  EndProcedure
  Procedure ExplorerComboGadget_(*any.integer,x,y,w,h,dir.s,flags)
    *any\i = ExplorerComboGadget(#pb_any,x,y,w,h,dir.s,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure ExplorerListGadget_(*any.integer,x,y,w,h,dir.s,flags)
    *any\i = ExplorerListGadget(#pb_any,x,y,w,h,dir.s,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure ExplorerTreeGadget_(*any.integer,x,y,w,h,dir.s,flags)
    *any\i = ExplorerTreeGadget(#pb_any,x,y,w,h,dir.s,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure FrameGadget_(*any.integer,x,y,w,h,text.s,flags)
    *any\i = FrameGadget(#pb_any,x,y,w,h,text.s,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure HyperLinkGadget_(*any.integer,x,y,w,h,text.s,color,flags)
    *any\i = HyperLinkGadget(#pb_any,x,y,w,h,text.s,color,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure ImageGadget_(*any.integer,x,y,w,h,imageid,flags)
    *any\i = ImageGadget(#pb_any,x,y,w,h,imageid,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure ListIconGadget_(*any.integer,x,y,w,h,col.s,colw,flags)
    *any\i = ListIconGadget(#pb_any,x,y,w,h,col.s,colw,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure ListViewGadget_(*any.integer,x,y,w,h,flags)
    *any\i = ListViewGadget(#pb_any,x,y,w,h,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure MDIGadget_(*any.integer,x,y,w,h,submenu,firstmenuitem,flags)
    *any\i = MDIGadget(#pb_any,x,y,w,h,submenu,firstmenuitem,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure OpenGLGadget_(*any.integer,x,y,w,h,flags)
    *any\i = OpenGLGadget(#pb_any,x,y,w,h,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure OptionGadget_(*any.integer,x,y,w,h,text.s)
    *any\i = OptionGadget(#pb_any,x,y,w,h,text.s)
    ProcedureReturn *any\i
  EndProcedure
  Procedure PanelGadget_(*any.integer,x,y,w,h)
    *any\i = PanelGadget(#pb_any,x,y,w,h)
    ProcedureReturn *any\i
  EndProcedure
  Procedure ProgressBarGadget_(*any.integer,x,y,w,h,min,max,flags)
    *any\i = ProgressBarGadget(#pb_any,x,y,w,h,min,max,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure ScrollAreaGadget_(*any.integer,x,y,w,h,scrollw,scrollh,scrollstep,flags)
    *any\i = ScrollAreaGadget(#pb_any,x,y,w,h,scrollw,scrollh,scrollstep,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure ScrollBarGadget_(*any.integer,x,y,w,h,min,max,page,flags)
    *any\i = ScrollBarGadget(#pb_any,x,y,w,h,min,max,page,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure ShortcutGadget_(*any.integer,x,y,w,h,shortcut)
    *any\i = ShortcutGadget(#pb_any,x,y,w,h,shortcut)
    ProcedureReturn *any\i
  EndProcedure
  Procedure SpinGadget_(*any.integer,x,y,w,h,min,max,flags)
    *any\i = SpinGadget(#pb_any,x,y,w,h,min,max,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure SplitterGadget_(*any.integer,x,y,w,h,gad1,gad2,flags)
    *any\i = SplitterGadget(#pb_any,x,y,w,h,gad1,gad2,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure StringGadget_(*any.integer,x,y,w,h,text.s,flags)
    *any\i = StringGadget(#pb_any,x,y,w,h,text.s,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure TextGadget_(*any.integer,x,y,w,h,text.s,flags)
    *any\i = TextGadget(#pb_any,x,y,w,h,text.s,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure TrackBarGadget_(*any.integer,x,y,w,h,min,max,flags)
    *any\i = TrackBarGadget(#pb_any,x,y,w,h,min,max,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure TreeGadget_(*any.integer,x,y,w,h,flags)
    *any\i = TreeGadget(#pb_any,x,y,w,h,flags)
    ProcedureReturn *any\i
  EndProcedure
  Procedure WebGadget_(*any.integer,x,y,w,h,url.s)
    *any\i = WebGadget(#pb_any,x,y,w,h,url.s)
    ProcedureReturn *any\i
  EndProcedure

  ;}

  ;{ Font
  Procedure LoadFont_(*any.integer,name.s,height,f)
    *any\i = LoadFont(#pb_any,name.s,height,f)
    ProcedureReturn *any\i
  EndProcedure

  ;}

  ;{ Pack
  Procedure CreatePack_(*any.integer,file.s,p,level)
    *any\i = CreatePack(#pb_any,file.s,p,level)
    ProcedureReturn *any\i
  EndProcedure
  Procedure OpenPack_(*any.integer,file.s,p)
    *any\i = OpenPack(#pb_any,file.s,p)
    ProcedureReturn *any\i
  EndProcedure

  ;}

  ;{ Statusbar
  Procedure CreateStatusBar_(*any.integer,windowid)
    *any\i = CreateStatusBar(#pb_any,windowid)
    ProcedureReturn *any\i
  EndProcedure

  ;}
EndModule

DeclareModule NoAny
  EnableExplicit
  Macro SetGadgetEvent(a,c)
    _noany::_BindGadgetEvent(a,c,change)
    _noany::_BindGadgetEvent(a,c,focus)
    _noany::_BindGadgetEvent(a,c,lostfocus)
    _noany::_BindGadgetEvent(a,c,leftclick)
    _noany::_BindGadgetEvent(a,c,rightclick)
    _noany::_BindGadgetEvent(a,c,mouseenter)
    _noany::_BindGadgetEvent(a,c,mouseleave)
    _noany::_BindGadgetEvent(a,c,mousemove)
    _noany::_BindGadgetEvent(a,c,mousewheel)
    _noany::_BindGadgetEvent(a,c,leftbuttondown)
    _noany::_BindGadgetEvent(a,c,leftbuttonup)
    _noany::_BindGadgetEvent(a,c,leftdoubleclick)
    _noany::_BindGadgetEvent(a,c,rightbuttondown)
    _noany::_BindGadgetEvent(a,c,rightbuttonup)
    _noany::_BindGadgetEvent(a,c,rightdoubleclick)
    _noany::_BindGadgetEvent(a,c,middlebuttondown)
    _noany::_BindGadgetEvent(a,c,middlebuttonup)
    _noany::_BindGadgetEvent(a,c,keydown)
    _noany::_BindGadgetEvent(a,c,keyup)
    _noany::_BindGadgetEvent(a,c,input)
    _noany::_BindGadgetEvent(a,c,resize)
    _noany::_BindGadgetEvent(a,c,up)
    _noany::_BindGadgetEvent(a,c,down)
    CompilerIf Defined(c#_all,#PB_Procedure)
      BindGadgetEvent(a,@c#_all(),#PB_All)
    CompilerEndIf
  EndMacro
  macro SetWindowEvent(any,c)
    _NoAny::_BindEvent(any,c,menu)
    _NoAny::_BindEvent(any,c,gadget)
    _NoAny::_BindEvent(any,c,systray)
    _NoAny::_BindEvent(any,c,timer)
    _NoAny::_BindEvent(any,c,CloseWindow)
    _NoAny::_BindEvent(any,c,Repaint)
    _NoAny::_BindEvent(any,c,sizewindow)
    _NoAny::_BindEvent(any,c,movewindow)
    _NoAny::_BindEvent(any,c,minimizewindow)
    _NoAny::_BindEvent(any,c,maximizewindow)
    _NoAny::_BindEvent(any,c,restorewindow)
    _NoAny::_BindEvent(any,c,activatewindow)
    _NoAny::_BindEvent(any,c,deactivatewindow)
    _NoAny::_BindEvent(any,c,windowdrop)
    _NoAny::_BindEvent(any,c,gadgetdrop)
    _NoAny::_BindEvent(any,c,rightclick)
    _NoAny::_BindEvent(any,c,leftclick)
    _NoAny::_BindEvent(any,c,leftdoubleclick)
  EndMacro


  ;{ Window
  Macro OpenWindow(any,x,y,width,height,title,flag=0,parentID=0)
    _noAny::OpenWindow_(@any,x,y,width,height,title,flag,parentID)
    noany::SetWindowEvent(any,any)
  EndMacro
  Macro OpenWindow_noEvent(any,x,y,width,height,title,flag=0,parentID=0)
    _noAny::OpenWindow_(@any,x,y,width,height,title,flag,parentID)
  EndMacro

  ;}

  ;{ Image
  Macro CatchImage(any,adr,size)
    _noAny::CatchImage_(@any,adr,size)
  EndMacro
  Macro CopyImage(img1,any)
    _noAny::CopyImage_(img1,@any)
  EndMacro
  Macro CreateImage(any,w,h,d=24,b=#Black)
    _noAny::CreateImage_(@any,w,h,d,b)
  EndMacro
  Macro GrabImage(img1,any,x,y,w,h)
    _noAny::GrabImage_(img1,@any,x,y,w,h)
  EndMacro
  Macro LoadImage(any,file,flag=0)
    _noAny::LoadImage_(@any,file,flag)
  EndMacro

  ;}

  ;{ Menu
  Macro CreateImageMenu(any, winid,flags=0)
    _noAny::CreateImageMenu_(@any, winid,flags)
  EndMacro
  Macro CreateMenu(any,winid)
    _noAny::CreateMenu_(@any,winid)
  EndMacro
  Macro CreatePopupImageMenu(any, flags=0)
    _noAny::CreatePopupImageMenu_(@any, flags)
  EndMacro
  Macro CreatePopupMenu(any)
    _noAny::CreatePopupMenu_(@any)
  EndMacro

  ;}

  ;{ gadget
  Macro ButtonGadget(any,x,y,w,h,text,flags=0)
    _noAny::ButtonGadget_(@any,x,y,w,h,text,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro ButtonGadget_noEvent(any,x,y,w,h,text,flags=0)
    _noAny::ButtonGadget_(@any,x,y,w,h,text,flags)
  EndMacro
  Macro ButtonImageGadget(any,x,y,w,h,imgid,flags=0)
    _noAny::ButtonImageGadget_(@any,x,y,w,h,imgid,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro ButtonImageGadget_noEvent(any,x,y,w,h,imgid,flags=0)
    _noAny::ButtonImageGadget_(@any,x,y,w,h,imgid,flags)
  EndMacro
  Macro CalendarGadget(any,x,y,w,h,d=0,f=0)
    _noAny::CalendarGadget_(@any,x,y,w,h,d,f)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro CalendarGadget_noEvent(any,x,y,w,h,d=0,f=0)
    _noAny::CalendarGadget_(@any,x,y,w,h,d,f)
  EndMacro
  Macro CanvasGadget(any,x,y,w,h,f=0)
    _noAny::CanvasGadget_(@any,x,y,w,h,f)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro CanvasGadget_noEvent(any,x,y,w,h,f=0)
    _noAny::CanvasGadget_(@any,x,y,w,h,f)
  EndMacro
  Macro CheckBoxGadget(any,x,y,w,h,t,f=0)
    _noAny::CheckBoxGadget_(@any,x,y,w,h,t,f)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro CheckBoxGadget_noEvent(any,x,y,w,h,t,f=0)
    _noAny::CheckBoxGadget_(@any,x,y,w,h,t,f)
  EndMacro
  Macro ComboBoxGadget(any,x,y,w,h,f=0)
    _noAny::ComboBoxGadget_(@any,x,y,w,h,f)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro ComboBoxGadget_noEvent(any,x,y,w,h,f=0)
    _noAny::ComboBoxGadget_(@any,x,y,w,h,f)
  EndMacro
  Macro ContainerGadget(any,x,y,w,h,f=#PB_Container_BorderLess)
    _noAny::ContainerGadget_(@any,x,y,w,h,f)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro ContainerGadget_noEvent(any,x,y,w,h,f=#PB_Container_BorderLess)
    _noAny::ContainerGadget_(@any,x,y,w,h,f)
  EndMacro
  Macro DateGadget(any,x,y,w,h,m,d,f=0)
    _noAny::DateGadget_(@any,x,y,w,h,m,d,f)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro DateGadget_noEvent(any,x,y,w,h,m,d,f=0)
    _noAny::DateGadget_(@any,x,y,w,h,m,d,f)
  EndMacro
  Macro EditorGadget(any,x,y,w,h,f=0)
    _noAny::EditorGadget_(@any,x,y,w,h,f)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro EditorGadget_noEvent(any,x,y,w,h,f=0)
    _noAny::EditorGadget_(@any,x,y,w,h,f)
  EndMacro
  Macro ExplorerComboGadget(any,x,y,w,h,dir,flags=0)
    _noAny::ExplorerComboGadget_(@any,x,y,w,h,dir,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro ExplorerComboGadget_noEvent(any,x,y,w,h,dir,flags=0)
    _noAny::ExplorerComboGadget_(@any,x,y,w,h,dir,flags)
  EndMacro
  Macro ExplorerListGadget(any,x,y,w,h,dir,flags=0)
    _noAny::ExplorerListGadget_(@any,x,y,w,h,dir,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro ExplorerListGadget_noEvent(any,x,y,w,h,dir,flags=0)
    _noAny::ExplorerListGadget_(@any,x,y,w,h,dir,flags)
  EndMacro
  Macro ExplorerTreeGadget(any,x,y,w,h,dir,flags=0)
    _noAny::ExplorerTreeGadget_(@any,x,y,w,h,dir,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro ExplorerTreeGadget_noEvent(any,x,y,w,h,dir,flags=0)
    _noAny::ExplorerTreeGadget_(@any,x,y,w,h,dir,flags)
  EndMacro
  Macro FrameGadget(any,x,y,w,h,text,flags=0)
    _noAny::FrameGadget_(@any,x,y,w,h,text,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro FrameGadget_noEvent(any,x,y,w,h,text,flags=0)
    _noAny::FrameGadget_(@any,x,y,w,h,text,flags)
  EndMacro
  Macro HyperLinkGadget(any,x,y,w,h,text,color,flags=0)
    _noAny::HyperLinkGadget_(@any,x,y,w,h,text,color,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro HyperLinkGadget_noEvent(any,x,y,w,h,text,color,flags=0)
    _noAny::HyperLinkGadget_(@any,x,y,w,h,text,color,flags)
  EndMacro
  Macro ImageGadget(any,x,y,w,h,imageid,flags=0)
    _noAny::ImageGadget_(@any,x,y,w,h,imageid,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro ImageGadget_noEvent(any,x,y,w,h,imageid,flags=0)
    _noAny::ImageGadget_(@any,x,y,w,h,imageid,flags)
  EndMacro
  Macro ListIconGadget(any,x,y,w,h,col,colw,flags=0)
    _noAny::ListIconGadget_(@any,x,y,w,h,col,colw,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro ListIconGadget_noEvent(any,x,y,w,h,col,colw,flags=0)
    _noAny::ListIconGadget_(@any,x,y,w,h,col,colw,flags)
  EndMacro
  Macro ListViewGadget(any,x,y,w,h,flags=0)
    _noAny::ListViewGadget_(@any,x,y,w,h,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro ListViewGadget_noEvent(any,x,y,w,h,flags=0)
    _noAny::ListViewGadget_(@any,x,y,w,h,flags)
  EndMacro
  Macro MDIGadget(any,x,y,w,h,submenu,firstmenuitem,flags=0)
    _noAny::MDIGadget_(@any,x,y,w,h,submenu,firstmenuitem,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro MDIGadget_noEvent(any,x,y,w,h,submenu,firstmenuitem,flags=0)
    _noAny::MDIGadget_(@any,x,y,w,h,submenu,firstmenuitem,flags)
  EndMacro
  Macro OpenGLGadget(any,x,y,w,h,flags=0)
    _noAny::OpenGLGadget_(@any,x,y,w,h,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro OpenGLGadget_noEvent(any,x,y,w,h,flags=0)
    _noAny::OpenGLGadget_(@any,x,y,w,h,flags)
  EndMacro
  Macro OptionGadget(any,x,y,w,h,text)
    _noAny::OptionGadget_(@any,x,y,w,h,text)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro OptionGadget_noEvent(any,x,y,w,h,text)
    _noAny::OptionGadget_(@any,x,y,w,h,text)
  EndMacro
  Macro PanelGadget(any,x,y,w,h)
    _noAny::PanelGadget_(@any,x,y,w,h)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro PanelGadget_noEvent(any,x,y,w,h)
    _noAny::PanelGadget_(@any,x,y,w,h)
  EndMacro
  Macro ProgressBarGadget(any,x,y,w,h,min,max,flags=0)
    _noAny::ProgressBarGadget_(@any,x,y,w,h,min,max,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro ProgressBarGadget_noEvent(any,x,y,w,h,min,max,flags=0)
    _noAny::ProgressBarGadget_(@any,x,y,w,h,min,max,flags)
  EndMacro
  Macro ScrollAreaGadget(any,x,y,w,h,scrollw,scrollh,scrollstep=10,flags=0)
    _noAny::ScrollAreaGadget_(@any,x,y,w,h,scrollw,scrollh,scrollstep,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro ScrollAreaGadget_noEvent(any,x,y,w,h,scrollw,scrollh,scrollstep=10,flags=0)
    _noAny::ScrollAreaGadget_(@any,x,y,w,h,scrollw,scrollh,scrollstep,flags)
  EndMacro
  Macro ScrollBarGadget(any,x,y,w,h,min,max,page,flags=0)
    _noAny::ScrollBarGadget_(@any,x,y,w,h,min,max,page,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro ScrollBarGadget_noEvent(any,x,y,w,h,min,max,page,flags=0)
    _noAny::ScrollBarGadget_(@any,x,y,w,h,min,max,page,flags)
  EndMacro
  Macro ShortcutGadget(any,x,y,w,h,shortcut)
    _noAny::ShortcutGadget_(@any,x,y,w,h,shortcut)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro ShortcutGadget_noEvent(any,x,y,w,h,shortcut)
    _noAny::ShortcutGadget_(@any,x,y,w,h,shortcut)
  EndMacro
  Macro SpinGadget(any,x,y,w,h,min,max,flags=0)
    _noAny::SpinGadget_(@any,x,y,w,h,min,max,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro SpinGadget_noEvent(any,x,y,w,h,min,max,flags=0)
    _noAny::SpinGadget_(@any,x,y,w,h,min,max,flags)
  EndMacro
  Macro SplitterGadget(any,x,y,w,h,gad1,gad2,flags=0)
    _noAny::SplitterGadget_(@any,x,y,w,h,gad1,gad2,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro SplitterGadget_noEvent(any,x,y,w,h,gad1,gad2,flags=0)
    _noAny::SplitterGadget_(@any,x,y,w,h,gad1,gad2,flags)
  EndMacro
  Macro StringGadget(any,x,y,w,h,text,flags=0)
    _noAny::StringGadget_(@any,x,y,w,h,text,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro StringGadget_noEvent(any,x,y,w,h,text,flags=0)
    _noAny::StringGadget_(@any,x,y,w,h,text,flags)
  EndMacro
  Macro TextGadget(any,x,y,w,h,text,flags=0)
    _noAny::TextGadget_(@any,x,y,w,h,text,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro TextGadget_noEvent(any,x,y,w,h,text,flags=0)
    _noAny::TextGadget_(@any,x,y,w,h,text,flags)
  EndMacro
  Macro TrackBarGadget(any,x,y,w,h,min,max,flags=0)
    _noAny::TrackBarGadget_(@any,x,y,w,h,min,max,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro TrackBarGadget_noEvent(any,x,y,w,h,min,max,flags=0)
    _noAny::TrackBarGadget_(@any,x,y,w,h,min,max,flags)
  EndMacro
  Macro TreeGadget(any,x,y,w,h,flags=0)
    _noAny::TreeGadget_(@any,x,y,w,h,flags)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro TreeGadget_noEvent(any,x,y,w,h,flags=0)
    _noAny::TreeGadget_(@any,x,y,w,h,flags)
  EndMacro
  Macro WebGadget(any,x,y,w,h,url)
    _noAny::WebGadget_(@any,x,y,w,h,url)
    noany::SetGadgetEvent(any,any)
  EndMacro
  Macro WebGadget_noEvent(any,x,y,w,h,url)
    _noAny::WebGadget_(@any,x,y,w,h,url)
  EndMacro

  ;}

  ;{ Font
  Macro LoadFont(any,name,height,f=0)
    _noAny::LoadFont_(@any,name,height,f)
  EndMacro

  ;}

  ;{ Pack
  Macro CreatePack(any,file,p=#PB_PackerPlugin_Zip,level=9)
    _noAny::CreatePack_(@any,file,p,level)
  EndMacro
  Macro OpenPack(any,file,p=#PB_PackerPlugin_Zip)
    _noAny::OpenPack_(@any,file,p)
  EndMacro

  ;}

  ;{ Statusbar
  Macro CreateStatusBar(any,windowid)
    _noAny::CreateStatusBar_(@any,windowid)
  EndMacro

  ;}

EndDeclareModule
Module NoAny
EndModule

UseModule NoAny
compilerendif



